# pyground. A collection of utility and wrapper classes
# Copyright (C) 2004 David Soulayrol <dsoulayrol@free.fr>
#
# This file is part of pyground.
#
# pyground is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""
[TODO: to be wrote]
"""

import os, sys

from distutils.command.install import install
from distutils.util import subst_vars
from distutils import log


# Redifine build_py of distutils.command.build_py so as to
# generate our configuration module on the fly.
class generate_and_install(install):
    """Subclass of install from distutils.

    [FIXME]
    """
    def run (self):
        # Obviously have to build before we can install
        if not self.skip_build:
            self.run_command('build')

            
        self.generate_conf()

        if not self.dry_run:
            self.finish_run()
        

    def finish_run(self):
        #
        # From distutils.command.install.install.py
        #
        # Run all sub-commands (at least those that need to be run)
        for cmd_name in self.get_sub_commands():
            self.run_command(cmd_name)

        if self.path_file:
            self.create_path_file()

        # write list of installed files, if requested.
        if self.record:
            outputs = self.get_outputs()
            if self.root:
                root_len = len(self.root)
                for counter in xrange(len(outputs)):
                    outputs[counter] = outputs[counter][root_len:]
            self.execute(write_file,
                         (self.record, outputs),
                         "writing list of installed files to '%s'" %
                         self.record)

        sys_path = map(os.path.normpath, sys.path)
        sys_path = map(os.path.normcase, sys_path)
        install_lib = os.path.normcase(os.path.normpath(self.install_lib))
        if (self.warn_dir and
            not (self.path_file and self.install_path_file) and
            install_lib not in sys_path):
            log.debug(("modules installed to '%s', which is not in "
                       "Python's module search path (sys.path) -- " 
                       "you'll have to change the search path yourself"),
                      self.install_lib)


    def generate_conf(self):
        raise NotImplementedError, \
              "abstract method -- subclass %s must override it" % self.__class__
