# pyground. A collection of utility and wrapper classes
# Copyright (C) 2004 David Soulayrol <dsoulayrol@free.fr>
#
# This file is part of pyground.
#
# pyground is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""
[TODO: to be wrote]
"""

import logging, sys


def __configure(aName, aLevel, aHandler):
    lLogger = logging.getLogger(aName)
    lFormatter = logging.Formatter(
        '%(asctime)s %(filename)s \t %(levelname)s \t %(message)s')
    aHandler.setFormatter(lFormatter)
    lLogger.addHandler(aHandler)
    lLogger.setLevel(aLevel)
    return lLogger


def createWithFilename(aName = 'default',
                       aLevel = logging.INFO,
                       aFilename = 'log'):
    
    return __configure(aName, aLevel, logging.FileHandler(aFilename))


def createWithStream(aName = 'default',
                     aLevel = logging.INFO,
                     aStream = sys.stdout):
    
    return __configure(aName, aLevel, logging.StreamHandler(aStream))


def createWithSocket(aName = 'default',
                     aLevel = logging.INFO,
                     aHost = 'localhost',
                     aPort = 5000):
    
    return __configure(
        aName, aLevel, logging.handlers.SocketHandler(aHost, aPort))



# TODO
class LogsReader(object):
    """Read and merge logs.
    """
    pass
